require 'kero/xmlelt'

=begin
The XML Parser itself. One instance can be used to parse several I/O-streams.
=end
class XmlParser
  def initialize(elements, anon=AnonXml)
    @anon = anon
    @hash = Hash.new(@anon)
    if elements != nil then
      elements.each do |cls|
	@hash.store(cls.xmlName(), cls)
      end
    end
  end

  def parseStream(f)
    parseString(f.read || "", 0)
  end

  def parseString(str, index, par_elt=nil)
    while str.index( /\s*(<([^\s=<>\/>]+))/m, index) == index
      (print "<#{$2}"; $stdout.flush)  if $DEBUG
      index += $&.length
      tag = $2
      cls = @hash[tag]
      elt = (cls == @anon) ? cls.new(tag) : cls.new()

      while str.index( /\s+([^\s=<>\/]+)(="([^"]*)")?/m, index) == index
	(print " #{$1}=\"#{$3}\""; $stdout.flush)  if $DEBUG
	index += $&.length
	elt.addAttribute($1, $3)
      end

      if str.index( /\s*(\/?)>/m, index) == index
	(print "#{$1}>\n"; $stdout.flush)  if $DEBUG
	index += $&.length
	if '/' != $1
	  dummy, str, index = parseString(str, index, elt)
	  if str.index( /\s*<\/([^\s=<>\/]+)>/m, index) == index
	    index += $&.length
	    (print "</#{$1}>\n"; $stdout.flush)  if $DEBUG
	    raise "Closing tag `#{$1}' did not match opening `#{tag}'"  if $1 != tag
	  end
	end
	par_elt.addChild(elt)  if par_elt
      end
    end
    return elt, str, index
  end
end

#File.open("/home/kero/.rb-pim/address.xml", "r") { |f|
#  XmlParser.new().parseStream(f.read)
#}
